#!/usr/bin/ruby
DIR=File.dirname((
  f = __FILE__
  while File.lstat(f).symlink?
    f = "#{File.dirname f}/#{File.readlink f}".gsub(/^.*\/\//, "/")
  end
  f
))
require "#{DIR}/../config"
require "#{DIR}/common"
require "socket"

data = nil
case ARGV.length
  when 0
    data = $stdin.read
  when 1
    data = "#{ARGV[0]}\n"
  when 2
    raise "unrecognized option `#{ARGV[0]}'" unless ARGV[0] == "-n"
    data = ARGV[1]
end

socket = UNIXSocket.force_new(DAEMON_SOCKET_FILE)
begin
  pgid = Process.getpgid($$)
  socket.puts pgid
  socket.write data
  socket.close_write
  filename = socket.read.chomp
  puts filename
ensure
  socket.force_close
end
