set -e
rm -rf test/dummy
ruby <<'END' &
  require "src/common"
  require 'src/rpc'
  require "socket"
  
  class Counter < RPC::Served_Object
    attr_reader :i
    def initialize
      @i = 0
    end
    
    served_method :count
    def count incr=1
      @i+=incr
    end
  end
  counter = Counter.new
  
  daemon = UNIXServer.new("test/dummy")
  socket = daemon.accept
  counter.serve socket
  counter.serve socket
  counter.serve socket
  socket.force_close
  daemon.force_close
END
R="$(ruby <<'END'
  require "src/common"
  require 'src/rpc'
  require "socket"
  
  socket = UNIXSocket.force_new("test/dummy")
  begin
    msg = "foobar-baz/quux!"
    remote = RPC::Proxy.new socket
    raise "FAIL" unless remote.count == 1
    raise "FAIL" unless remote.count(3) == 4
    begin
      remote.count("invalid")
    rescue TypeError
      puts "PASS"
    end
  ensure
    socket.force_close
  end
END
)"
[ "$R" == "PASS" ]
wait $!
